/*This program takes voltage measurements from the output of a joystick(potentiometer(s))and sends out "f", "b", "l", "r" commands
through the use of an XBee module. 
*/

#include "simpletools.h"                     
#include "fdserial.h"                        
#include "adcDCpropab.h"                     

fdserial *xbee;                           // Initialize the full-duplex serial connection over XBee

int main()                                // Main program 
{
  xbee = fdserial_open( 9, 8, 0, 9600 );  // Open the serial connection
         adc_init( 21, 20, 19, 18 );      // Initialize the analog connections for the joystick
  float lrV, udV;                         // Create 2 float values for incoming joystick values
 
  while ( 1 )                             // run loop indefentley
  {
    udV = adc_volts( 2 );                 // Get values from the joystick through input AD2
    lrV = adc_volts( 3 );                 // Get values from the joystick through input AD3
    
    if ( udV < 1.00 )                     // If joystick udV voltage is less than 1.00V send back(b) command
    {
      dprint( xbee, "b" );
    }
     
    else if ( udV > 4.00 )                // If joystick udV voltage is greater than 4.00V send forward(f) command
    {
      dprint( xbee, "f" );
    }
     
    else if ( udV < 3.00 && udV > 2.00 && lrV < 3.00 && lrV > 2.00 ) // If joystick is centered udV and lrV will be in between
                                                                     // 2.00V and 3.00V which sends the stop(s)command
    {
      dprint( xbee, "s" );
    }
     
  else if ( lrV < 2.00 )                // If joystick lrV is less than 2.00V send left(l) conmmand
    {
      dprint( xbee, "l" );
    }
     
    else if ( lrV > 4.00 )              // If joysitck lrV is greater than 4.00V send right(r) command
    {
      dprint( xbee, "r" );
   }
    pause( 50 );                        // Only need to check joystick values 20 times a second
  }
}