/*This application uses PWM to drive two DC motors. Maximum PMW is set at 1000 with command "pwm_start(1000)". This application program is entended 
for use with a two H-bridges in this case the Pololu Motor Driver Carrier Board(28820). Also used in this application two DC gear motors(28819)
P3 and P4 are used to drive the motors in a forward motion(includes turning). P2 and P5 are used to move in reverse. If you want to use only one
motor comment out or remove pins 3 and 4 OR pins 2 and 5 from the code.
*/
#include "simpletools.h"
#include "fdserial.h"
#include "abdrive.h"

int main()                                 // Main function  
{
  pause(250);
  // Keep pins low if unused.
  set_outputs(5, 2, 0b0000);
  set_directions(5, 2, 0b1111);
  
  fdserial *xbee;
                                             
{
  xbee = fdserial_open( 9, 8, 0, 9600 );   // Begin the serial connection ( this is why we
                                           // needed the jumper cables connected to pins 8 and 9 )
  char data; 
                                           // Create the variable that will be used to hold incoming data
  pwm_start(1000); 
                                              
  while ( 1 )                              // Repeat this forever or until loss of power
  {
    data = fdserial_rxChar( xbee );        // Set data to the data received from the XBee board
 
    
    if ( data == 'f' )                     // If the data incoming is telling the robot to move forward
    {
    //(pin, pwm channel, 800/1000)         // Move forward 80 percent speed (800 of 1000)                                      
     pwm_set(3, 1,800);                    // left wheel command set
     pwm_set(4, 0,800);                    // right wheel command set
                                   
    }
    //(pin, pwm channel, 800/1000)
    else if ( data == 'b' )                // If the data incoming is telling the robot to move backward, move backwards
    {
                                           // Move backwards 80 percent speed (800 of 1000)
      pwm_set(2, 0,800);                   // left wheel command
      pwm_set(5, 1,800);                   // right wheel command                                       
    }
    
   
    else if ( data == 'l' )                // If the data incoming is telling the robot to turn left, turn left
    {                                      // Turn right motor faster than left motor to make a right turn
      pwm_set(4, 0,850);                   // right wheel command
      pwm_set(3, 1,550);                   // left wheel command                               
    }
    
    else if ( data == 'r' )                // If the data incoming is telling the robot to turn right, turn right
    {                                      // Turn left motor faster than right to make a right turn
      pwm_set(3, 0, 850);                   
      pwm_set(4, 1, 550);                           
    }
    
    else if ( data == 's' )                // If the data incoming is telling the robot to stop, then stop
    {                                      
      pwm_set(2, 0, 0);  
      pwm_set(5, 1, 0); 
      pwm_set(3, 0, 0);
      pwm_set(4, 1, 0);                           
    }  
    

}
}
}
